#!/usr/bin/python
# -*- coding: utf-8 -*-

import time
import sys
import getopt
import string
import threading
import os
import multiprocessing

def ncount( n ) : # тестовая CPU-загружающая функция
    while n > 0 : n -= 1

repnum = 10000000
thrnum = 2
mode = 'stmp' 

try : 
    opts, args = getopt.getopt( sys.argv[1:], "t:n:m:" )
except getopt.GetoptError :
    print "недопустимая опция команды или её значение"
    sys.exit( 2 )
for opt, arg in opts :
    if cmp( opt[ 1: ], 't' ) == 0 : thrnum = string.atoi( arg )
    if cmp( opt[ 1: ], 'n' ) == 0 : repnum = string.atoi( arg )
    if cmp( opt[ 1: ], 'm' ) == 0 : mode = arg
    
print "число процессоров (ядер) = %i" % multiprocessing.cpu_count()
print "исполнение в Python версия %s" % sys.version[ :string.index( sys.version, '\n' ) ]
print "число ветвей выполнения %i" % thrnum
print "число циклов в ветви %i" % repnum

if 's' in mode :
    print "============ последовательное выполнение ============"
    clc = time.time()
    for i in range( thrnum ) : ncount( repnum )
    clc = time.time() - clc
    print "время %5.2f секунд" % clc


if 't' in mode :
    print "================ параллельные потоки ================"
    threads = []
    for n in range( thrnum ) :
        tid = threading.Thread( target = ncount, args=( repnum, ) )
        threads.append( tid )
        tid.setDaemon( 1 )
    clc = time.time()
    for n in range( thrnum ) : threads[ n ].start()
    for n in range( thrnum ) : threads[ n ].join()
    clc = time.time() - clc
    print "время %5.2f секунд" % clc

if 'p' in mode :
    print "=============== параллельные процессы ==============="
    threads = []
    clc = time.time()
    for n in range( thrnum ) :
        try : pid = os.fork();
        except :
            print "error: create child process"
            sys.exit( 33 )
        if pid == 0 :
            ncount( repnum )
            sys.exit( 3 )
        if pid > 0 :
            threads.append( pid )
    for p in threads :
        pid, status = os.wait()
    clc = time.time() - clc
    print "время %5.2f секунд" % clc

if 'm' in mode :
    print "=============== модуль multiprocessing =============="
    parms = []
    pool = multiprocessing.Pool( processes = thrnum, )
    for n in range( thrnum ) :
        parms.append( repnum )
    clc = time.time()
    pool.map( ncount, parms )
    clc = time.time() - clc
    print "время %5.2f секунд" % clc

